/*=============================================================================
 =                      Common foxfm preferences source code
 =============================================================================*/

/******************************************************************************
 Loading of external libraries/modules
 ******************************************************************************/
/* load external module 'Preferences.js' into the scope of 'foxfm
   --> prefix 'foxfm.' need to be used at function calls of this module */
var foxfm = {};
Components.utils.import("resource://modules/Preferences.js", foxfm);

/* global variables for preference handling */
var prefBranchOFMStrengthLevel		= new foxfm.Preferences("foxfm.pref.ofm.strengthlevel.");
var prefBranchAbout					= new foxfm.Preferences("foxfm.pref.about.");
var prefBranchOFMFunctionSettings	= new foxfm.Preferences("foxfm.pref.ofm.");
var prefBranchExpertSettings		= new foxfm.Preferences("foxfm.expert.");
var prefBranchAddOn					= new foxfm.Preferences("foxfm.pref.");

function foxfm_isConfigurationDatabaseActivated()
{
	var configDBActivated = null;

	try
	{
		infoMessage(4, "foxfm_isConfigurationDatabaseActivated(): started");
        
        configDBActivated = prefBranchAddOn.get("configurationdatabase.activated");
		
		infoMessage(4, "foxfm_isConfigurationDatabaseActivated(): Configurationdatabase activated: " + configDBActivated);
	} catch (e) {
		errorMessage(e);
	}
	return configDBActivated;
}

function foxfm_getPathToConfigurationDatabase()
{
	var nsILFPathToDatabase = null;

	try
	{
		infoMessage(4, "foxfm_getPathToConfigurationDatabase(): started");

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("foxfm.pref.");
		nsILFPathToDatabase = prefs.getComplexValue("configurationdatabase.path", Components.interfaces.nsILocalFile);
		
		infoMessage(4, "foxfm_getPathToConfigurationDatabase(): Path to database: " + nsILFPathToDatabase.path);
	} catch (e) {
		errorMessage(e);
	}
	return nsILFPathToDatabase;
}

function foxfm_getPrefOFMDomain()
{
	try
	{
        var sOFMDomain = prefBranchOFMFunctionSettings.get("domain");
        infoMessage(6, "foxfm_getPrefOFMDomain(): OFM Domain: " + sOFMDomain);
		return sOFMDomain;
	}
	catch(e)
	{
		errorMessage(e);
	}		
}

function foxfm_getPrefOFMDomainLocalisation()
{
	try
	{
        var sOFMDomainLocalisation = prefBranchOFMFunctionSettings.get("domain.localisation");
        infoMessage(6, "foxfm_getPrefOFMDomain(): OFM Domain: " + sOFMDomainLocalisation);
		return sOFMDomainLocalisation;
	}
	catch(e)
	{
		errorMessage(e);
	}		
}

function foxfm_setPrefOFMDomain(sDomain)
{
	try
	{
		return prefBranchOFMFunctionSettings.set("domain", sDomain);
	}
	catch(e)
	{
		errorMessage(e);
	}		
}
