/*============================================================================
 foxfm expert mode:
             The expert mode provideds the possibility to change essential 
             addon configuration information. These changes must only be 
             done if necessary and with absolut carefulness!

 feature #1: Each item, e.g. buttons. text fiels etc. on the OFM-Websites are 
             accessed by the addon using a XPATH. An OFM-Website corresponds to
             an OFM menuitem. This XPATH is saved within the addon using the 
             configuration database. The following dataset is saved:

             OFM-Website(menuitem) : Website-Item : XPATH

             The expert mode allows to change this dataset which is usually 
             necessary due to changes on the OFM websites.
 =============================================================================*/

/******************************************************************************
 foxfm expert mode objects
 ******************************************************************************/
function Foxfm_ExpertMode_xPathTree()
{
	try
	{
		this.tree;

		this.db_getXpathTree = function (document, aResult, object)
		{
			try
			{
				infoMessage(3, "db_getXpathTree(): started: " + object.aBlockNames);
				
				if(aResult)
				{
					object.aBlockNames = new Array();
					var i=0;
					for(var row=aResult.getNextRow(); row; row=aResult.getNextRow()) 
					{
						var value = row.getResultByName("att_block_name");
						
						infoMessage(3, "db_getBlockNames(): " + i + ": " + value);
						object.aBlockNames[i] = value;
						i++;
					}
				} else {
					errorMessage("Could not get xpath tree from the database.");
				}
			} catch (e) {
				errorMessage(e);
			}
			infoMessage(3, "db_getXpathTree(): finished: " + object.aBlockNames);
		};
		this.init = function()
		{
			try
			{
				var sql	= "SELECT att_block_name FROM tbl_block_name";
				foxfm_db_executeStatement(document, null, sql, this.db_getBlockNames, this);
			} catch (e) {
				errorMessage(e);
			}
		};
		this.init();
	} catch (e) {
		errorMessage(e);
	}
}

/******************************************************************************
 foxfm expert mode globals
 *****************************************************************************/
// Initialisation due to asynchronous database access
var gExpertModeMenue_xPathTree	= new Foxfm_ExpertMode_xPathTree();

/******************************************************************************
 foxfm expert mode functions
 *****************************************************************************/
function foxfm_expertmode(document)
{
	try
	{
		if(foxfm_isOFMDomain(document.location.href) && prefBranchExpertSettings.get("active")) 
		{
			infoMessage(0, "foxfm_expertmode(document): started");
			var ofmMenu = new Foxfm_OFM_Menu(document);
            infoMessage(0, ofmMenu.aMenu);
			var foxfm_tree_xpath_settings = document.getElementById("foxfm_tree_xpath_settings");
			infoMessage(0, "foxfm_expertmode(): xpath-tree: "+ foxfm_tree_xpath_settings);
		}		
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_expertMode_buildXpathTree(xpathTree)
{
	try
	{
		infoMessage(0, "foxfm_expertMode_buildXpathTree(): started: tree.col: " + xpathTree);
    } catch (e){
        errorMessage(e);
    }
    return;
}

function foxfm_expertmode_initPopupMenu(document)
{
	try
	{

    } catch (e){
        errorMessage(e);
    }
    return;
}